#this is for GoogleFit only

import datetime
import utils

def getConnections(d):
	from SPARQLWrapper import SPARQLWrapper, DIGEST, JSON

	sparql = SPARQLWrapper("http://carre.kmi.open.ac.uk:8890/sparql-auth")
	sparql.setHTTPAuth(DIGEST)
	sparql.setCredentials("dba", "DBA_PASSWORD_HERE")
	sql = """
		SELECT DISTINCT ?g as ?graphName ?s as ?manufacturer ?o as ?date ?o2 as ?firstConnected
		WHERE {
		  GRAPH ?g {
		    ?s <http://carre.kmi.open.ac.uk/ontology/sensors.owl#last_measured> ?o .
		   FILTER((\""""+d+"""\"^^xsd:date>?o)&&(str(?s) = "http://carre.kmi.open.ac.uk/manufacturers/googlefit"))
		  }
		}
	  """
	# print sql


	sparql.setQuery(sql)

	sparql.setReturnFormat(JSON)
	results = sparql.query().convert()
	services = results['results']['bindings']
	return services


def updateGoogleFit():
	import requests
	import json
	yesterday = (datetime.date.today()+datetime.timedelta(-1)).strftime("%Y-%m-%d")
	connections = getConnections(yesterday)
	rs = 0
	for connection in connections:
		date = connection['date']['value']
		d = datetime.datetime.strptime(date, "%Y-%m-%d").date()
		graphName = connection['graphName']['value']
		manufacturer = connection['manufacturer']['value']
		ownerId = utils.getUsernameFromGraphName(graphName)
		date = connection['date']['value']
		date = datetime.datetime.strptime(date, "%Y-%m-%d").date()
		date= date.strftime("%Y-%m-%d %H:%M:%S")
		data = {}
		data['start_date'] = date
		data['end_date'] = (d + datetime.timedelta(days=1)).strftime("%Y-%m-%d %H:%M:%S")
		data['user_id'] = ownerId
		rs = requests.post("https://carre.kmi.open.ac.uk/tomcat/responder/googlefit", data=json.dumps(data),verify=False)
		utils.updateLastMeasured(graphName, "googlefit", d)

	return rs
